<template>
  <div class="app">
    <h2 class="text-center mt-4 mb-4 text">User</h2>
    <div class="container-fluid">
      <div class="table-responsive">
        <table class="table">
          <thead class="thead-dark">
            <tr>
              <th v-for="column in columns" class="text">
                {{ column }}
              </th>
            </tr>
          </thead>
          <tbody class="text">
            <tr v-for="user in users">
              <td class="text-center">{{ user.id }}</td>
              <td>
                <span v-show="!isEditing">{{ user.username }}</span>
                <input
                  v-show="isEditing"
                  placeholder="User Name"
                  v-model="user.username"
                  type="text"
                />
              </td>
              <td>
                <span v-show="!isEditing">{{ user.email }}</span>
                <input
                  v-show="isEditing"
                  placeholder="Email"
                  v-model="user.email"
                  type="text"
                />
              </td>
              <td>
                <span v-show="!isEditing">{{ user.password }}</span>
                <input
                  v-show="isEditing"
                  placeholder="Password"
                  v-model="user.password"
                  type="password"
                />
              </td>
              <td>
                <span v-show="!isEditing">{{ user.role }}</span>
                <input
                  v-show="isEditing"
                  placeholder="role"
                  v-model="user.role"
                  type="text"
                />
              </td>
              <td>
                <div>
                  <a
                    v-show="!isEditing"
                    href="#!"
                    @click="updateUser()"
                    class="btn btn-warning"
                    >Edit</a
                  >
                  <a
                    v-show="!isEditing"
                    href="#!"
                    @click="deleteUser(user)"
                    class="btn btn-danger"
                    >Delete</a
                  >
                  <a
                    v-show="isEditing"
                    href="#!"
                    @click="saveUser(user)"
                    class="btn btn-primary"
                    >Save</a
                  >
                </div>
              </td>
            </tr>
            <tr>
              <td>
                <div class="text">#</div>
              </td>

              <td>
                <div class="input-field">
                  <input
                    placeholder="User Name"
                    v-model="input.username"
                    id="username"
                    type="text"
                  />
                </div>
              </td>
              <td>
                <div class="input-field">
                  <input
                    placeholder="Email"
                    v-model="input.email"
                    id="email"
                    type="text"
                  />
                </div>
              </td>
              <td>
                <div class="input-field">
                  <input
                    placeholder="Password"
                    v-model="input.password"
                    id="password"
                    type="password"
                  />
                </div>
              </td>
              <td>
                <div class="input-field">
                  <input
                    placeholder="role"
                    v-model="input.role"
                    id="role"
                    type="role"
                  />
                </div>
              </td>
              <td>
                <a href="#!" @click="createUser" class="btn btn-success"
                  ><i class="material-icons">Add</i></a
                >
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</template>

<script>

export default {
  props: ["username", "email", "password", "role"], //propriétés passée du parent au fils
  mounted() {
    if (localStorage.getItem('id')) {
      this.user.id = localStorage.getItem('id')
      this.user.token = localStorage.getItem('token')
    }
    this.fetchUsers();
  },
  data() {
    return {
      user: {
        id: "",
        token: "",
        role: ""
      },
      columns: ["Id", "User Name", "Email", "Password", "Role", "Actions "],
      users: [],
      input: {
        username: "",
        email: "",
        password: null,
        role: ""
      },
      isEditing: false,
    };
  },
  methods: {
    async fetchUsers() {
      const url = "http://localhost:4000/api/users";
      let result = await (
        await fetch(url, {
          method: "GET",
          headers: {
            Accept: "application/json",
            "Content-Type": "application/json",
            'Authorization': `Bearer ${this.user.token}`
          },
        })
      ).json();
      this.users = result.data;
    },
    async createUser() {
      const url = "http://localhost:4000/api/users";
      await fetch(url, {
        method: "POST",
        headers: {
          Accept: "application/json",
          "Content-type": "application/json",
          'Authorization': `Bearer ${this.user.token}`
        },
        body: JSON.stringify({
          user: {
            username: this.input.username,
            email: this.input.email,
            password: this.input.password,
            role: this.input.role,
          },
        }),
      });
      await this.fetchUsers();
      this.input.username = "";
      this.input.email = "";
      this.input.password = "";
      this.input.role = "";
    },
    async updateUser() {
      this.isEditing = true;
    },
    async saveUser(user) {
      this.isEditing = false;
      const url = "http://localhost:4000/api/users/" + user.id;
      let newName = user.username;
      let newEmail = user.email;
      let newPassword = user.password;
      let newRole = user.role;
      await fetch(url, {
        method: "PUT",
        headers: {
          Accept: "application/json",
          "Content-type": "application/json",
          'Authorization': `Bearer ${this.user.token}`
        },
        body: JSON.stringify({
          user: {
            username: newName,
            email: newEmail,
            password: newPassword,
            role: newRole,
          },
        }),
      });
      await this.fetchUsers();
    },

    async deleteUser(user) {
      const url = "http://localhost:4000/api/users/" + user.id;
      await fetch(url, {
        method: "DELETE",
        headers: {
          Accept: "application/json",
          "Content-Type": "application/json",
          'Authorization': `Bearer ${this.user.token}`
        },
      });
      await this.fetchUsers();
    },
  },
};
</script>

<style>
.text {
  color: aliceblue;
}
</style>
